;
; Waterman's TTE version of Woodos classic crackintro from C64/Amiga.
;
; Info about Waterman:
;	From Sweden.
;	My friend had an C64 and 1541 drive in 1987 which we played around with dreaming to get the knowledge
; 	to do demos and crack games. We didn't succeed, but we had fun looking at demos.
;	Me and my friend could look at the crackintro by Triad for some time wondering how do they do that.
;   It was rasterbars with the text Cracked by MR Z.
;	1988 I saved money an bought an Amiga and I met a guy in school that had some knowledge to program.
;	He taught me a bit and I bought a book (can't remeber the name) and started styding and programming.
;	I managed to do some intros/demos and even was a member of a demogroup, for me this was big.
;	In 1994 i started to work with PC so the Amiga was put away. Unfortunate the Amiga went to bin in 2009 when moving. 😒
;	Sometimes I have played with WinUAE (not programming) just to get the feeling again.
;	2023 I found a Twitch stream with a guy cracking games on Amiga. The heaven opened itself (a Swedish expression).
;	Can I look at this stream and learn and do a crack myself????
;	Since that Wednesdays evenings are holy, look at stream, enjoy, learn and soak in informations. 
;	This has inspired med to do some coding.
;	So here is my version of the crackintro done by Woodo for Fairlight.
;
;	As you can see I'm not a graphic artist. So, anybody that wants to improve something, feel free.
;	
;
; Thanks to:
; 			H0ffman for inspiring me to pick up the Amiga again (WinUAE) ❤️
;			TTE members for sharing knowledge and kind treatment o7 ❤️
;			Photon for the Amiga Hardware Programming tutorial. ❤️
;			All people that keeping the Amiga alive and creating stuff. ❤️
;			
;	/Waterman 2024-05-17


		INCLUDE	"DEV:TTE-Woodo/Include/BareMetal.i"
;-----------------------------------------------------------
		SECTION	Code,CODE
		INCLUDE	"DEV:TTE-Woodo/Include/SafeStart.i"
		


Main:
		movem d0-a6,-(sp)
		lea.l	$dff000,a5
		lea.l	$dff000,a6

		lea.l	Screen,a0
		lea.l	BplPtrs+2,a1
		move.l a0,d2
		swap d2
		move.w d2,(a1)			;high word of address
		move.w a0,4(a1)			;low word of address
		addq.w #8,a1			;skip two copper instructions
		add.l #10240,a0
		move.l a0,d2
		swap d2
		move.w d2,(a1)			;high word of address
		move.w a0,4(a1)			;low word of address

		lea	mt_data,a0
		jsr	mt_init

		lea.l	Copperlist,a0
		move.l	a0,COP1LC(a5)
		move.w	#$81CF,DMACON(a5)

		jsr		PrintGameName
		jsr		PrintCrackedBy
.vblank 
		cmp.b	#250,VHPOSR(a5)
		bne	.vblank

		jsr ScroltextColors
		jsr	MoveRasterBar1
		
		jsr	Scroll
		jsr	mt_music

.waitmouse:
		btst 	#6,CIAAPRA
		beq	.exit
		bra	.vblank
		
		
.exit
		lea.l	$dff000,a6
		jsr	mt_end
		movem	(sp)+,d0-a6
		rts


Scroll:								;Scroll
BltBusy1:	
		BTST.B	#14-8,DMACONR(a5)	; Blitter still busy?
		BNE.B	BltBusy1			; If yes, wait a bit

		move.l #$f9f00000,BLTCON0(a5)
		move.l #$ffffffff,BLTAFWM(a5)
		move.l #Screen+7880,BLTAPTH(a5)
		move.l #Screen+7880-1,BLTDPTH(a5)
		move.w #0,BLTAMOD(a5)
		move.w #0,BLTDMOD(a5)
		move.w #10*1*64+20,BLTSIZE(a6)		

		move.l	#Scrollcount,a0
		add.w	#1,(a0)
		cmp.w	#8,(a0)				;Compare if time put new character
		beq		Putchar
		rts

									
Putchar:							;Put character
		move.w	#0,(a0)				;Reset Scrollcounter
		
		move.l	#0,d0
Getchar:				
		move.l	#Scrollpointer,a0
		move.l	(a0),a1
		move.b	(a1),d0
		
		cmp.b	#122,d0
		bne		Charready
		move.l	#Scrolltext,Scrollpointer
		bra		Getchar
Charready:		
		add.l	#1,Scrollpointer
		move.l	#Font,a2
		
Checkrow:		
		sub.b	#32,d0
		cmp.b	#19,d0
		bls 	Correctrow
Nextrow:		
		add.l	#520,a2				;Add 1 row - 8+5 height x 40
		sub.b	#20,d0
		cmp.b	#19,d0
		bls		Correctrow
		bra		Nextrow
	
Correctrow:
		mulu	#2,d0
		add.l	d0,a2
		
BltBusy2:
		BTST.B	#14-8,DMACONR(a5)	; Blitter still busy?
		BNE.B	BltBusy2			; If yes, wait a bit

		move.l #$09f00000,BLTCON0(a5)
		move.l #$ffffffff,BLTAFWM(a5)
		move.l a2,BLTAPTH(a5)
		move.l #Screen+7919,BLTDPTH(a5)
		move.w #38,BLTAMOD(a5)
		move.w #38,BLTDMOD(a5)
		move.w #10*1*64+1,BLTSIZE(a6)		

		rts

Scrollcount:	dc.w	0
Scrollpointer:	dc.l	Scrolltext
Scrolltext:		dc.b	'THE TWITCH ELITE IS BACK IN BUSINESS!! THIS TIME WITH A CLONE OF '
				dc.b	'THE INTRO MADE BY WOODO        '
				dc.b 	'z' 		;z Restart the scrolltext
				even

; Print Game Name				
			
PrintGameName:
		clr.l	d0
		clr.l	d1
		move.l	#Gamename,a0
		move.b	(a0),d0
		clr.l	d2					;Counter for which character to print
CharreadyPGN:		
		move.l	#Screen,a3
		add.l	#5960,a3			;Startpos to write game name
		add.l	d2,a3
		move.l	#Font,a2
		
CheckrowPGN:		
		sub.b	#32,d0
		cmp.b	#19,d0
		bls 	CorrectrowPGN
NextrowPGN:		
		add.l	#520,a2				;Add 1 row - 8+5 height x 40
		sub.b	#20,d0
		cmp.b	#19,d0
		bls		CorrectrowPGN
		bra		NextrowPGN
	
CorrectrowPGN:
		mulu	#2,d0
		add.l	d0,a2
		
		move.w	#7,d1				;How many lines to print
		
NextPGNByte:		
		move.b	(a2),(a3)
		add.l	#40,a3
		add.l	#40,a2
		dbf		d1,NextPGNByte
		
		add.l	#1,a0				;Next character
		move.b	(a0),d0				;Next character
		add.w	#1,d2				;Update counter / 2 bytes for each character
		cmp.w	#40,d2				;Check if we have done 40 characters
		beq		PrintGameNameDone
		bra		CharreadyPGN
PrintGameNameDone:
		rts
		
		
; Print Cracked By
				
PrintCrackedBy:

		clr.l	d0
		clr.l	d1
		move.l	#Crackedby,a0
		move.b	(a0),d0
		clr.l	d2					;Counter for which character to print
CharreadyPCB:		
		move.l	#Screen,a3
		add.l	#6600,a3			;Startpos to write Cracked By Name
		add.l	d2,a3
		move.l	#Font,a2
		
CheckrowPCB:		
		sub.b	#32,d0
		cmp.b	#19,d0
		bls 	CorrectrowPCB
NextrowPCB:		
		add.l	#520,a2				;Add 1 row - 18+6 height x 40
		sub.b	#20,d0
		cmp.b	#19,d0
		bls		CorrectrowPCB
		bra		NextrowPCB
	
CorrectrowPCB:
		mulu	#2,d0
		add.l	d0,a2
		
		move.w	#7,d1				;How many lines to print
		
NextPCBByte:		
		move.b	(a2),(a3)
		add.l	#40,a3
		add.l	#40,a2
		dbf		d1,NextPCBByte
		
		add.l	#1,a0				;Next character
		move.b	(a0),d0				;Next character
		add.w	#1,d2				;Update counter / 2 bytes for each character
		cmp.w	#40,d2				;Check if we have done 40 characters
		beq		PrintPCB
		bra		CharreadyPCB
PrintPCB:
		rts


				
Gamename:		dc.b	'               GAME NAME                 ',0 	;Needs to be 40 characters
Crackedby:		dc.b	'         CRACKED BY: XXXXXXXXXX          ',0  	;Needs to be 40 characters				
				even				

MoveRasterBar1:
		move.l 	#0,d2
		move.l	#0,d3
		move.l	#0,d1
		move.w  #3,d2				;Colors per row
		move.w	#28,d0				;Total rows of cop1bar
		lea	Raster1barSinuspointer,a0
		move.l	(a0),a1
		move.b	(a1),d1
		
		lea		Raster1BarDownOrUp,a0
		move.w	(a0),d3
		cmp.w	#1,d3
		beq		R1Down
R1Up:
		lea.l 	Raster1barsUp,a0
		bra		DoR1Bar
R1Down:		
		lea.l	Raster1barsDown,a0
		
DoR1Bar:
		lea.l	Rasterbar1Cop,a1
		add.l	#6,a1		
		mulu	#20,d1
		add.l	d1,a1
.NextColor:
		move.w	(a0),(a1)
		add.l	#2,a0
		add.l	#4,a1
		dbf		d2,.NextColor
		add.w	#4,a1
		move.w	#3,d2
		dbf		d0,.NextColor	

		add.l	#1,Raster1barSinuspointer
		lea	Raster1barSinuspointer,a2
		move.l	(a2),a1
		move.b	(a1),d1
		cmp.b	#255,d1
		bne	.SinusOK
		move.l	#Raster1barSinus,Raster1barSinuspointer
.SinusOK
		cmp.b 	#254,d1
		bne		TopOK
		add.l	#1,Raster1barSinuspointer
		move.w	#2,Raster1BarDownOrUp
		
TopOK:		
		cmp.b	#253,d1
		bne		EndsR1Bar
		add.l	#1,Raster1barSinuspointer
		move.w	#1,Raster1BarDownOrUp

EndsR1Bar:
		rts
		


									;1 = Down
									;2 = UP
Raster1BarDownOrUp:
		dc.w	1

Raster1barsDown:
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $00f0,$00f0,$00f0,$00f0
	dc.w $01f1,$01f1,$01f1,$01f1
	dc.w $02f2,$02f2,$02f2,$02f2
	dc.w $03f3,$03f3,$03f3,$03f3
	dc.w $05f5,$05f5,$05f5,$05f5
	dc.w $06f6,$06f6,$06f6,$06f6
	dc.w $07f7,$07f7,$07f7,$07f7
	dc.w $09f9,$09f9,$09f9,$09f9
	dc.w $0afa,$0afa,$0afa,$0afa
	dc.w $0cfc,$0cfc,$0cfc,$0cfc
	dc.w $0dfd,$0dfd,$0dfd,$0dfd
	dc.w $0efe,$0efe,$0efe,$0efe
	dc.w $0dfd,$0dfd,$0dfd,$0dfd
	dc.w $0cfc,$0cfc,$0cfc,$0cfc
	dc.w $0afa,$0afa,$0afa,$0afa
	dc.w $09f9,$09f9,$09f9,$09f9
	dc.w $07f7,$07f7,$07f7,$07f7
	dc.w $06f6,$06f6,$06f6,$06f6
	dc.w $05f6,$05f6,$05f6,$05f6
	dc.w $03f3,$03f3,$03f3,$03f3
	dc.w $02f2,$02f2,$02f2,$02f2
	dc.w $01f1,$01f1,$01f1,$01f1
	dc.w $00f0,$00f0,$00f0,$00f0
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd
	
Raster1barsUp:
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $00f0,$0a54,$0c65,$0ddd
	dc.w $01f1,$0a54,$0c65,$0ddd
	dc.w $02f2,$0a54,$0c65,$0ddd
	dc.w $03f3,$0a54,$0c65,$0ddd
	dc.w $05f5,$0a54,$0c65,$0ddd
	dc.w $06f6,$0a54,$0c65,$0ddd
	dc.w $07f7,$0a54,$0c65,$0ddd
	dc.w $09f9,$0a54,$0c65,$0ddd
	dc.w $0afa,$0a54,$0c65,$0ddd
	dc.w $0cfc,$0a54,$0c65,$0ddd
	dc.w $0dfd,$0a54,$0c65,$0ddd
	dc.w $0efe,$0a54,$0c65,$0ddd
	dc.w $0dfd,$0a54,$0c65,$0ddd
	dc.w $0cfc,$0a54,$0c65,$0ddd
	dc.w $0afa,$0a54,$0c65,$0ddd
	dc.w $09f9,$0a54,$0c65,$0ddd
	dc.w $07f7,$0a54,$0c65,$0ddd
	dc.w $06f6,$0a54,$0c65,$0ddd
	dc.w $05f6,$0a54,$0c65,$0ddd
	dc.w $03f3,$0a54,$0c65,$0ddd
	dc.w $02f2,$0a54,$0c65,$0ddd
	dc.w $01f1,$0a54,$0c65,$0ddd
	dc.w $00f0,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd
	dc.w $0000,$0a54,$0c65,$0ddd


									;255 End of Sinus
									;254 Top
									;253 Bottom

Raster1barSinus:
		dc.b 43,42,40,38,37,35,33,32,30,29,27,25,24,22,21,19
		dc.b 18,17,15,14,13,12,11,9,8,7,6,6,5,4,3,3
		dc.b 2,1,1,1,0,0,0,0,0,0,0,0,0,0,0,254
		dc.b 1,1,2,2,3,4,4,5,6,7,8,9,10,11,12,13,15
		dc.b 16,17,19,20,22,23,25,26,28,29,31,33,34,36,38,39
		dc.b 41,43,44,46,48,49,51,53,54,56,58,59,61,62,64,65
		dc.b 67,68,70,71,72,74,75,76,77,78,79,80,81,82,83,83
		dc.b 84,85,85,86,86,87,87,87,87,87,87,87,87,87,87,87,253
		dc.b 86,86,86,85,84,84,83,82,81,81,80,79,78,76,75,74
		dc.b 73,72,70,69,68,66,65,63,62,60,58,57,55,54,52,50
		dc.b 49,47,45,44
		dc.b 255
		even

Raster1barSinuspointer:
		dc.l	Raster1barSinus
		
ScroltextColors:
		clr.l	d0
		move.l	#ScrollColorsFrq,a0
		move.w	(a0),d0
		sub.w 	#1,d0
		cmp.w	#1,d0
		
		beq		StartScrolltextColors
		move.w	d0,(a0)
		rts
		

StartScrolltextColors:
		move.w	#5,ScrollColorsFrq
		move.l	#39,d0							;Colors per row 40
		move.l	#9,d1							;Rows to do 10
		move.l	#ScrolltextrasterbarColorsPointer,a2
		move.l	(a2),a0
		move.l	(a2),ChangingColorPointer
		move.l	#ScrolltextCopColors,a1
		add.l	#6,a1							;Startpoint to change colors
NextScrollColor:
		move.w	(a0),(a1)
		add.l	#2,a0							;Next Color
		cmp.w	#1,(a0)
		bne		DoNextColor
		move.l	#ChangingColorPointer,a2
		move.l	(a2),a0
DoNextColor:
		add.l	#4,a1							;Next pos to change
		dbf		d0,NextScrollColor
		;rts
		
		move.l	#ScrolltextrasterbarColorsPointer,a2
		move.l	(a2),a0
		
		add.l	#4,a1
		move.l	#39,d0
		dbf		d1,NextScrollColor

		add.l	#2,ScrolltextrasterbarColorsPointer
		move.l	#ScrolltextrasterbarColorsPointer,a0
		move.l	(a0),a2
		move.w	(a2),d0
		cmp.w	#1,d0
		bne		ColorOK
		move.l	#ScrolltextrasterbarColors,ScrolltextrasterbarColorsPointer
		move.l	#ScrolltextrasterbarColors,ChangingColorPointer		
ColorOK:		
		rts
		
ScrollColorsFrq:					dc.w 5 ;Every 54th frame		
ScrolltextrasterbarColorsRows: 		dc.w 10
ScrolltextrasterbarColorsPointer: 	dc.l ScrolltextrasterbarColors
ChangingColorPointer:				dc.l ScrolltextrasterbarColors
	
ScrolltextrasterbarColors:
	dc.w $0ccc
	dc.w $0ccc
	dc.w $0ccc
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0444
	dc.w $0444
	dc.w $0444
	dc.w $0444
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0ccc
	dc.w $0ccc
	dc.w $0ccc
	dc.w $0ccc
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0444
	dc.w $0444
	dc.w $0444
	dc.w $0444
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0ccc
	dc.w $0ccc
	dc.w $0ccc
	dc.w $0ccc
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0888
	dc.w $0ccc
	dc.w 1

	INCLUDE	"DEV:TTE2/Include/protracker.asm"

		
		
		SECTION DATA,DATA_C
Copperlist:
		dc.w $01fc,$0000		;Slow fetch mode, remove if AGA demo.
		dc.w $008e,$2c81		;238h display window top, left
		dc.w $0090,$2cc1		;and bottom, right.
		dc.w $0092,$0038		;Standard bitplane dma fetch start
		dc.w $0094,$00d0		;and stop for standard screen.
		dc.w $0106,$0c00		;(AGA compat. if any Dual Playf. mode)
		dc.w $0108,$0000		;modulo
		dc.w $010a,$0000		;modulo
		dc.w $0102,$0000		;Scroll register (and playfield pri)
		

Colors:
		dc.w $180,$0000			
		dc.w $182,$0aaa			
		dc.w $184,$0888			
		dc.w $186,$0ddd			

BplPtrs:
		dc.w $00e0,$0000
		dc.w $00e2,$0000
		dc.w $00e4,$0000
		dc.w $00e6,$0000
		dc.w $0100,$2000+$200	;Enable bitplanes

Rasterbar1Cop:
	dc.w $3101,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3201,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3301,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3401,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3501,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3601,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3701,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3801,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3901,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3a01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3b01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3c01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3d01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3e01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $3f01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4001,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4101,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4201,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4301,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4401,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4501,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4601,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4701,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4801,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4901,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4a01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4b01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4c01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4d01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4e01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $4f01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5001,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5101,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5201,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5301,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5401,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5501,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5601,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5701,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5801,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5901,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5a01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5b01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5c01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5d01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5e01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $5f01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6001,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6101,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6201,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6301,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6401,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6501,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6601,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6701,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6801,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6901,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6a01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6b01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6c01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6d01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6e01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $6f01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7001,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7101,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7201,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7301,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7401,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7501,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7601,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7701,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7801,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7901,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7a01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7b01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7c01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7d01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7e01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $7f01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8001,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8101,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8201,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8301,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8401,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8501,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8601,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8701,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8801,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8901,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8a01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8a01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8b01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8c01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8d01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8e01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $8f01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9001,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9101,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9201,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9301,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9401,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9501,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9601,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9701,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9801,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9901,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9a01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9b01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9c01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9d01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9e01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $9f01,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $a001,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $a101,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $a201,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $a301,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	dc.w $a401,$fffe,$0180,$0000,$0182,$0a54,$0184,$0c65,$0186,$0ddd
	
	dc.w $bf01,$fffe,$0182,$0000 ;Game name Rasterbar
	dc.w $c001,$fffe,$0180,$0a54 
	dc.w $c101,$fffe,$0180,$0a54
	dc.w $c201,$fffe,$0180,$0c65
	dc.w $c301,$fffe,$0180,$0c65
	dc.w $c401,$fffe,$0180,$0ddd
	dc.w $c501,$fffe,$0180,$0ddd
	dc.w $c601,$fffe,$0180,$0c65
	dc.w $c701,$fffe,$0180,$0c65
	dc.w $c801,$fffe,$0180,$0a54
	dc.w $c901,$fffe,$0180,$0a54
	
	dc.w $ca01,$fffe,$0180,$0000 ;Black background
	
	
	dc.w $d001,$fffe,$0180,$033e,$0182,$0000 ;Cracked by Rasterbar
	dc.w $d101,$fffe,$0180,$033e
	dc.w $d201,$fffe,$0180,$006b
	dc.w $d301,$fffe,$0180,$006b
	dc.w $d401,$fffe,$0180,$0ddd
	dc.w $d501,$fffe,$0180,$0ddd
	dc.w $d601,$fffe,$0180,$006b
	dc.w $d701,$fffe,$0180,$006b
	dc.w $d801,$fffe,$0180,$033e
	dc.w $d901,$fffe,$0180,$033e
	
	
	dc.w $0090,$2cb3
	dc.w $da01,$fffe,$0180,$0000 ;Black background	
	
	;Scrolltextrasterbar
ScrolltextCopColors:
	
	dc.w $f043,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f143,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f243,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f343,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f443,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f543,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f643,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f743,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f843,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff

	dc.w $f943,$fffe	;Wait
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0888
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0444
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0fff
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0ccc
	dc.w $0182,$0fff


	dc.w $fa01,$fffe,$0182,$0000
	
	dc.w	$ffff,$fffe


Screen:
	INCBIN "DEV:TTE-Woodo/TTELogo3.raw"
Font:
	INCBIN "DEV:TTE-Woodo/Font5.raw"	

	
mt_data:
	INCBIN "DEV:TTE-Woodo/druid_ii_v2_h0ffman.mod"
